Package io.vertx.reactivex.ext.web

## Class RequestBody

- java.lang.Object
- - io.vertx.reactivex.ext.web.RequestBody

- All Implemented Interfaces:
    `io.vertx.lang.rx.RxDelegate`

      public class RequestBody
      extends Object
      implements io.vertx.lang.rx.RxDelegate

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static io.vertx.lang.rx.TypeArg<RequestBody>` | `__TYPE_ARG` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `RequestBody​(RequestBody delegate)` |
    `RequestBody​(Object delegate)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `JsonArray` | `asJsonArray()` |
    `JsonArray` | `asJsonArray​(int maxAllowedLength)` | Gets the current body buffer as a .
    `JsonObject` | `asJsonObject()` |
    `JsonObject` | `asJsonObject​(int maxAllowedLength)` | Gets the current body buffer as a .
    `<R> R` | `asPojo​(Class<R> clazz)` |
    `<R> R` | `asPojo​(Class<R> clazz, int maxAllowedLength)` |
    `String` | `asString()` |
    `String` | `asString​(String encoding)` | Get the entire HTTP request body as a string, assuming the specified encoding.
    `boolean` | `available()` | Return `true` if a `BodyHandler` was executed before this call in the lifetime of the request.
    `Buffer` | `buffer()` |
    `boolean` | `equals​(Object o)` |
    `RequestBody` | `getDelegate()` |
    `int` | `hashCode()` |
    `boolean` | `isEmpty()` | A body can be empty if it is not available, or its length is `0`.
    `int` | `length()` | Returns the total length of the body buffer.
    `static RequestBody` | `newInstance​(RequestBody arg)` |
    `String` | `toString()` |

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### __TYPE_ARG

          public static final io.vertx.lang.rx.TypeArg<RequestBody> __TYPE_ARG

  - ### Constructor Detail

    - #### RequestBody

          public RequestBody​(RequestBody delegate)

    - #### RequestBody

          public RequestBody​(Object delegate)

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### equals

          public boolean equals​(Object o)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### getDelegate

          public RequestBody getDelegate()

      Specified by:
        `getDelegate` in interface `io.vertx.lang.rx.RxDelegate`

    - #### asString

          public String asString()

      Returns:
        the entire HTTP request body as a string, assuming UTF-8 encoding if the request does not provide the content type charset attribute. If a charset is provided in the request that it shall be respected. The context must have first been routed to a `BodyHandler` for this to be populated.

    - #### asString

          public String asString​(String encoding)

      Get the entire HTTP request body as a string, assuming the specified encoding. The context must have first been routed to a `BodyHandler` for this to be populated.
      Parameters:
        `encoding` - the encoding, e.g. "UTF-16"
      Returns:
        the body

    - #### asJsonObject

          public JsonObject asJsonObject​(int maxAllowedLength)

      Gets the current body buffer as a . If a positive limit is provided the parsing will only happen if the buffer length is smaller or equal to the limit. Otherwise an `IllegalStateException` is thrown. When the application is only handling uploads in JSON format, it is recommended to set a limit on `BodyHandler.setBodyLimit(long)` as this will avoid the upload to be parsed and loaded into the application memory.
      Parameters:
        `maxAllowedLength` - if the current buffer length is greater than the limit an `IllegalStateException` is thrown. This can be used to avoid DDoS attacks on very long JSON payloads that could take over the CPU while attempting to parse the data.
      Returns:
        Get the entire HTTP request body as a . The context must have first been routed to a `BodyHandler` for this to be populated.
        When the body is `null` or the `"null"` JSON literal then `null` is returned.

    - #### asJsonArray

          public JsonArray asJsonArray​(int maxAllowedLength)

      Gets the current body buffer as a . If a positive limit is provided the parsing will only happen if the buffer length is smaller or equal to the limit. Otherwise an `IllegalStateException` is thrown. When the application is only handling uploads in JSON format, it is recommended to set a limit on `BodyHandler.setBodyLimit(long)` as this will avoid the upload to be parsed and loaded into the application memory.
      Parameters:
        `maxAllowedLength` - if the current buffer length is greater than the limit an `IllegalStateException` is thrown. This can be used to avoid DDoS attacks on very long JSON payloads that could take over the CPU while attempting to parse the data.
      Returns:
        Get the entire HTTP request body as a . The context must have first been routed to a `BodyHandler` for this to be populated.
        When the body is `null` or the `"null"` JSON literal then `null` is returned.

    - #### asJsonObject

          public JsonObject asJsonObject()

      Returns:
        Get the entire HTTP request body as a . The context must have first been routed to a `BodyHandler` for this to be populated.
        When the body is `null` or the `"null"` JSON literal then `null` is returned.

    - #### asJsonArray

          public JsonArray asJsonArray()

      Returns:
        Get the entire HTTP request body as a . The context must have first been routed to a `BodyHandler` for this to be populated.
        When the body is `null` or the `"null"` JSON literal then `null` is returned.

    - #### buffer

          public Buffer buffer()

      Returns:
        Get the entire HTTP request body as a . The context must have first been routed to a `BodyHandler` for this to be populated.

    - #### asPojo

          public <R> R asPojo​(Class<R> clazz,
                              int maxAllowedLength)

      Parameters:
        `clazz` -
        `maxAllowedLength` - if the current buffer length is greater than the limit an `IllegalStateException` is thrown. This can be used to avoid DDoS attacks on very long JSON payloads that could take over the CPU while attempting to parse the data.
      Returns:
        Get the entire HTTP request body as a POJO. The context must have first been routed to a `BodyHandler` for this to be populated.
        When the body is `null` or the `"null"` JSON literal then `null` is returned. WARNING: This feature requires jackson-databind. Or another JSON codec that implements POJO parsing

    - #### asPojo

          public <R> R asPojo​(Class<R> clazz)

      Parameters:
        `clazz` -
      Returns:
        Get the entire HTTP request body as a POJO. The context must have first been routed to a `BodyHandler` for this to be populated.
        When the body is `null` or the `"null"` JSON literal then `null` is returned. WARNING: This feature requires jackson-databind. Or another JSON codec that implements POJO parsing

    - #### length

          public int length()

      Returns the total length of the body buffer. This is the length in bytes. When there is no buffer the length is `-1`.
      Returns:
        length in bytes.

    - #### isEmpty

          public boolean isEmpty()

      A body can be empty if it is not available, or its length is `0`.
      Returns:
        `true` if empty.

    - #### available

          public boolean available()

      Return `true` if a `BodyHandler` was executed before this call in the lifetime of the request.
      Returns:
        `true` if body was parsed during the duration of the request.

    - #### newInstance

          public static RequestBody newInstance​(RequestBody arg)